/* 
 * Thomas Pantzer: t_deq_l.h, v0.4.7  8.6.99 16:32 
 * 
 * 
 * Copyright 1999 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@isys2.informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */






#ifndef T_DEQ_L_H
#define T_DEQ_L_H


#include "t_deq.h"

class t_deq_l : public t_deq {

public:	
	void Init(int i, double a, t_deq *N);

	virtual void Show(t_vertex_2i *vcenter, double size_, t_deq *BP, t_deq *BF, t_deq *SE);
	virtual double Error(t_vector &Df, double ds, double da_avg, double ds_avg);	
	virtual void Update(double factor, t_vector &Df, double ds, double da_avg, double ds_avg);

	virtual double Angle_Drift(char);
	char ComparesTo(t_deq *other);

// advanced error function
	double Diff2Neighbour(t_deq_l *N, char LR);
	double ErrorCos3(t_vector &Df,  double ds, double da_avg, double ds_avg);

// private:
	double rise_left,rise_right;
};






#endif







/**/
/**/
/**/
/**/
/**/
/**/
/**/
/**/
/*****  End Of File  ****************************/
